/////////////////////////////////////////////////////////////////////////////
//
//  Soubor: WinApiComboBox.cpp
//	
//  (C) 2002 Radek Chalupa
//
/////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <tchar.h>

#include "resource.h"

void NaInitDialog(HWND hWnd)
{
	SendDlgItemMessage(hWnd, IDC_DROPDOWN, CB_ADDSTRING, 0, (LPARAM)_T("1. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPDOWN, CB_ADDSTRING, 0, (LPARAM)_T("2. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPDOWN, CB_ADDSTRING, 0, (LPARAM)_T("3. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPDOWN, CB_ADDSTRING, 0, (LPARAM)_T("4. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPDOWN, CB_ADDSTRING, 0, (LPARAM)_T("5. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPDOWN, CB_ADDSTRING, 0, (LPARAM)_T("6. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPDOWN, CB_SETCURSEL, 0, 0);

	SendDlgItemMessage(hWnd, IDC_DROPLIST, CB_ADDSTRING, 0, (LPARAM)_T("1. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPLIST, CB_ADDSTRING, 0, (LPARAM)_T("2. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPLIST, CB_ADDSTRING, 0, (LPARAM)_T("3. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPLIST, CB_ADDSTRING, 0, (LPARAM)_T("4. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPLIST, CB_ADDSTRING, 0, (LPARAM)_T("5. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPLIST, CB_ADDSTRING, 0, (LPARAM)_T("6. dek"));
	SendDlgItemMessage(hWnd, IDC_DROPLIST, CB_SETCURSEL, 2, 0);

	SendDlgItemMessage(hWnd, IDC_SIMPLE, CB_ADDSTRING, 0, (LPARAM)_T("1. dek"));
	SendDlgItemMessage(hWnd, IDC_SIMPLE, CB_ADDSTRING, 0, (LPARAM)_T("2. dek"));
	SendDlgItemMessage(hWnd, IDC_SIMPLE, CB_ADDSTRING, 0, (LPARAM)_T("3. dek"));
	SendDlgItemMessage(hWnd, IDC_SIMPLE, CB_ADDSTRING, 0, (LPARAM)_T("4. dek"));
	SendDlgItemMessage(hWnd, IDC_SIMPLE, CB_ADDSTRING, 0, (LPARAM)_T("5. dek"));
	SendDlgItemMessage(hWnd, IDC_SIMPLE, CB_ADDSTRING, 0, (LPARAM)_T("6. dek"));
	SendDlgItemMessage(hWnd, IDC_SIMPLE, CB_SETCURSEL, 2, 0);
	SendMessage(hWnd, WM_SETICON, ICON_SMALL,
		(LPARAM)LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_HLAVNI)));
}

void NaRozbalit(HWND hWnd)
{
	SendDlgItemMessage(hWnd, IDC_DROPDOWN, CB_SHOWDROPDOWN, (WPARAM)TRUE, 0);
	SendDlgItemMessage(hWnd, IDC_DROPDOWN, CB_SETCURSEL, (WPARAM)4, 0);
}

void NaZmenaVyberu(HWND hCombo)
{
	LRESULT vyber = SendMessage(hCombo, CB_GETCURSEL, 0, 0);
	SendDlgItemMessage(GetParent(hCombo), IDC_SIMPLE, CB_SETCURSEL, vyber, 0);
}

void ZjistiTextPolozky(HWND hCombo)
{
	LPTSTR lpText;
	LRESULT vyber = SendMessage(hCombo, CB_GETCURSEL, 0, 0);
	LRESULT delkaTextu = SendMessage(hCombo, CB_GETLBTEXTLEN, vyber, 0);
	lpText = (LPTSTR)HeapAlloc(GetProcessHeap(), 0,
		(delkaTextu+1) * sizeof(TCHAR));
	SendMessage(hCombo, CB_GETLBTEXT, vyber, (LPARAM)lpText);
	SetDlgItemText(GetParent(hCombo), IDC_COMBO_TEXT, lpText);
	HeapFree(GetProcessHeap(), 0, lpText);
}

/////////////////////////////////////////////////////////////////////////////
// Procedura dialogu

INT_PTR CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				case IDC_ROZBALIT:
					NaRozbalit(hWnd);
					break;
				case IDC_DROPDOWN:
				case IDC_DROPLIST:
					if ( HIWORD(wParam) == CBN_SELCHANGE)
						NaZmenaVyberu((HWND)lParam);
					break;
				case IDC_SIMPLE:
					ZjistiTextPolozky((HWND)lParam);
					break;
			}
			break;
		case WM_INITDIALOG:
			NaInitDialog(hWnd);
			break;
	}
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Hlavn funkce programu pro Windows

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_HLAVNI), NULL, DialogProc);
	return 0;
}
